<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.3.2
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla-code.ru
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

$user = & JFactory::getUser();
if ($user->get('gid') < 19 ) {
	JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
}

jimport('joomla.application.component.controller');

class SmfaqControllerAdmin extends SmfaqController
{
	
	function edit()
	{
		$user = & JFactory::getUser();
		$view = & $this->getView('smfaq', 'html');
		$model = $this->getModel('smfaq');
		
		if ( $model->isCheckedOut($user->get('id')))
		{
			$catid  	= JRequest::getInt( 'catid', 0);
			$msg = JText::_('COM_SMFAQ_THIS_QUESTION');
			$this->setRedirect($_SERVER['HTTP_REFERER'], $msg);
			return;
		}
		$view->setModel($model, true);
		$model->checkout();

		$view->display();
	}
	
	function save()	
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$user = & JFactory::getUser();
		$model = $this->getModel('smfaq');
		$model->checkin();
		$post = JRequest::get('post');
		if ($user->gid > '23') {
			$post['answer'] = JRequest::getVar('answer', '', 'post', 'string', JREQUEST_ALLOWRAW);
		} else {
			$post['answer'] = JRequest::getVar('answer', '', 'post', 'string', JREQUEST_ALLOWHTML);
		}
		
		if ($model->store($post)) {	
			$msg = JText::_( 'COM_SMFAQ_GREETING_SAVED!' );
			
			$send_mail = JRequest::getVar( 'send_mail', 0);
			$published = JRequest::getVar( 'published', 0);
			$state     = JRequest::getVar( 'state', 0);
			if ($send_mail && $published && ($state == 2)){
				$this->sendUser();
			}
			$referer = JRequest::getString('ret',  base64_encode(JURI::base()), 'get');
			$referer = base64_decode($referer);
			$this->setRedirect($referer, $msg);
		} else {
			$this->setError($model->getError());
			$this->display();
		}
		
	}
	
	function cancel()
	{
		$model = $this->getModel('smfaq');
		$model->checkin();

		$referer = JRequest::getString('ret', base64_encode(JURI::base()), 'get');
		$referer = base64_decode($referer);
		if (!JURI::isInternal($referer)) {
			$referer = '';
		}
		$this->setRedirect($referer);
	}

	function delete()
	{
		$id = JRequest::getVar('id', 0, '', 'int');
		
		$db			= & JFactory::getDBO();
		$query = 'DELETE FROM #__smfaq' .
				' WHERE id =' . $id;
		$db->setQuery($query);
		
		if (!$db->query())
		{
			JError::raiseError( 500, $db->getErrorMsg() );
			return false;
		}
		$msg = JText::_('COM_SMFAQ_DELETE_SUCCESSFULLY');
		echo $msg;
		return;
	}
	
	function sendUser()
	{
		require_once(JPATH_COMPONENT_SITE.DS.'helpers'.DS.'route.php');
		global $mainframe;
		
		$SiteName	= $mainframe->getCfg('sitename');
		$email		= JRequest::getVar( 'email',		'',			'post' );
		$question	= JRequest::getVar( 'question',			'',			'post' );
		$MailFrom 	= $mainframe->getCfg('mailfrom');
		$FromName 	= $mainframe->getCfg('fromname');
		$catid  	= JRequest::getInt('catid');
		$id  	= JRequest::getInt('id');
		$subject	= JText::_( 'COM_SMFAQ_ANSWER_QUESTION');
		$body = JText::sprintf('COM_SMFAQ_ON_YOUR_QUESTION', JURI::root());
		$body .= "\n\n" . $question;
		$link = preg_replace("/(.*).$/", "\\1", JURI::root()).'/'.JRoute::_(SmfaqHelperRoute::getQuestionRoute($catid, $id));
		$body .= "\n\n" . JText::sprintf('COM_SMFAQ_PUBLISHED_ANSWER', $link);
		$mail = JFactory::getMailer();
		
		$mail->addRecipient( $email );
		$mail->setSender( array( $MailFrom, $FromName ) );
		$mail->setSubject( $subject );
		$mail->setBody( $body );
		
		$sent = $mail->Send();
	}
	
	function shownoanswer()
	{
		$catid  	= JRequest::getInt( 'catid', 0);
		$ret = $_SERVER['HTTP_REFERER']; 
		$db		=& JFactory::getDBO();
		$query = 'SELECT id, catid, created, question' .
				' FROM #__smfaq' .
				' WHERE catid ='. (int) $catid . ' AND published = 0' .
				' ORDER BY created';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();
		
		if ($rows) {
			$html = '<table id="smnopublish" class="smnopublish" border="1" cellpadding="5">';
			foreach ($rows as $row) {
				$html .= '<tr id="sm-'.$row->id.'"><td style="text-align:center;">'.JHTML::_('date', $row->created, '%d-%m-%Y %H:%M:%S').'</td>'; 
				$html .= '<td><a title="'.JText::_('COM_SMFAQ_EDIT').'" href="index.php?option=com_smfaq&controller=admin&task=edit&catid='.$row->catid.'&id='.$row->id.'&ret='. base64_encode($ret) .'">'.$row->question.'</a></td>';
				$html .= '<td><img style="cursor:pointer" border="0" alt="'. JText::_( 'COM_SMFAQ_DELETE' ).'" src="components/com_smfaq/images/delete.png"/ onclick="if (confirm(\''. JText::_('COM_SMFAQ_CONFIRM_DELETE').'\')) del('.$row->id.', this);"></td>';
			}
			$html .='</tr></table>';
		} else {
			$html = '<div style="margin-top:20px;" onmouseover="this.parentNode.removeChild(this)">'.JText::_('COM_SMFAQ_ITEMS_NO_FOUND').'</div>';
		}
		echo $html;
		return;
	}
	
	function delcomment()
	{
		$id = JRequest::getVar('id', 0, '', 'int');
		
		$db			= & JFactory::getDBO();
		$query = 'DELETE FROM #__smfaq_comments' .
				' WHERE id =' . $id;
		$db->setQuery($query);
		
		if (!$db->query())
		{
			JError::raiseError( 500, $db->getErrorMsg() );
			return false;
		}
		$msg = JText::_('COM_SMFAQ_DELETE_SUCCESSFULLY');
		echo $msg;
		return;
	}
}



	

