<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.3.2
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla-code.ru
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

class SmfaqModelCategory extends JModel
{
	/**
	 * category id
	 *
	 * @var int
	 */
	var $_id = null;

	/**
	 * category Data array
	 *
	 * @var array
	 */
	var $_data = null;

	/**
	 * category total
	 *
	 * @var integer
	 */
	var $_total = null;

	/**
	 * category
	 *
	 * @var object
	 */
	var $_category = null;

	/**
	 * Pagination object
	 *
	 * @var object
	 */
	var $_pagination = null;

	/**
	 * Constructor
	 *
	 * @since 1.5
	 */
	function __construct()
	{
		parent::__construct();

		global $mainframe;

		$config = JFactory::getConfig();

		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();

		if (is_object( $menu ) && $menu->query['view'] == 'category') {
			$params = new JParameter( $menu->params );
		} else {
			$params = &$mainframe->getParams('com_smfaq');
		}

		// Get the pagination request variables
		$this->setState('limit', $mainframe->getUserStateFromRequest('com_smfaq.limit', 'limit', $params->get('display_num'), 'int'));
		$this->setState('limitstart', JRequest::getVar('limitstart', 0, '', 'int'));

		// In case limit has been changed, adjust limitstart accordingly
		$this->setState('limitstart', ($this->getState('limit') != 0 ? (floor($this->getState('limitstart') / $this->getState('limit')) * $this->getState('limit')) : 0));


		$id = JRequest::getVar('id', 0, '', 'int');
		$this->setId((int)$id);
	}

	function setId($id)
	{
		// Set category ID and wipe data
		$this->_id			= $id;
		$this->_category	= null;
		$this->_data		= array();
	}

	function getData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));

			$total = count($this->_data);
			for($i = 0; $i < $total; $i++)
			{
				$item =& $this->_data[$i];
			}
		}

		return $this->_data;
	}


	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}


	function getCategory()
	{
		// Load the Category data
		if ($this->_loadCategory()) {
			// Initialize some variables
			$user = &JFactory::getUser();
			//		    Make sure the category is published
			if (!$this->_category->published) {
				JError::raiseError(404, JText::_("Resource Not Found"));
				return false;
			}
			// check whether category access level allows access
			if ($this->_category->access > $user->get('aid', 0)) {
				JError::raiseError(403, JText::_("ALERTNOTAUTH"));
				return false;
			}
		}
		return $this->_category;
	}

	function _loadCategory()
	{
		if (empty($this->_category)) {
			// current category info
			$query = 'SELECT c.*, ' .
			' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as slug '.
			' FROM #__categories AS c' .
			' WHERE c.id = '. (int) $this->_id .
			' AND c.section = "com_smfaq"';
			$this->_db->setQuery($query, 0, 1);
			$this->_category = $this->_db->loadObject();
		}
		return true;
	}

	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		$user = &JFactory::getUser();
		if ($user->get('gid') > 19) {
			$query = 'SELECT a.*, v.vote_yes AS v_yes, v.vote_no AS v_no, c.id AS comments ' .
			' FROM #__smfaq AS a ' .
			' LEFT JOIN #__smfaq_votes AS v ON v.question_id = a.id ' .
			' LEFT JOIN #__smfaq_comments AS c ON c.question_id = a.id' .
			$where .
			$orderby;
		} else {
			$query = 'SELECT a.*' .
			' FROM #__smfaq AS a' .
			$where .
			$orderby;
		}
		return $query;
	}

	function _buildContentWhere()
	{
		$where = ' WHERE a.catid = '. (int) $this->_id. ' AND a.published = 1 ';
		return $where;
	}

	function _buildContentOrderBy()
	{
		global $mainframe;
		$user = &JFactory::getUser();
		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();

		if (is_object( $menu ) && $menu->query['view'] == 'category') {
			$params = new JParameter( $menu->params );
		} else {
			$params = &$mainframe->getParams('com_smfaq');
		}

		$orderby = ' ORDER BY ';

		switch ($params->get('order_question'))
		{
			case '1':
				$orderby .= 'a.created DESC';
				break;
			case '2':
				$orderby .= 'a.created ASC';
				break;
			case '3':
				$orderby .= 'a.question ASC';
				break;
			case '0':
			default:
				$orderby .= 'a.ordering';
				break;
		}

		return $orderby;
	}

	function getDataForAdmin() {

	}
}
