<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.3.2
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla-code.ru
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class SmfaqViewCategory extends JView
{
	function display( $tpl = null )
	{
		global $mainframe;
		
		// Initialize some variables
		$document	= &JFactory::getDocument();
		$uri 		= &JFactory::getURI();
		$pathway	= &$mainframe->getPathway();
		$user = &JFactory::getUser();

		// Get some data from the model
		$items = &$this->get('data' );
		$total = &$this->get('total');
		$pagination = &$this->get('pagination');
		$category = &$this->get('category' );
		$state = &$this->get('state');
		
		// Get the parameters of the active menu item
		$menus = &JSite::getMenu();
		$menu  = $menus->getActive();
		
		$category->total = $total;
		
		if (is_object( $menu ) && $menu->query['view'] == 'category') {
			$params = new JParameter( $menu->params );
			$itemid = $menu->id;
			
			if (!$params->get( 'page_title')) {
				$params->set('page_title', $category->title);
			}
		} else {
			$params = &JComponentHelper::getParams( 'com_smfaq' );
			$params->set('page_title',	$category->title);
			$params->def('display_num',				0);
			$params->def('show_pagination_limit',	0);
			$params->def('add_question',			2);
			$params->def('show_vote', 0);
			$itemid = null;
			$params->set('page_title', $category->title);
		}
		$document->setTitle( $params->get( 'page_title' ) );
		
		
		// Add alternate feed link
		if($params->get('show_feed_link', 1) == 1)
		{
			$link	= '&view=category&id='.$category->slug.'&format=feed&limitstart=';
			$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
			$document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
			$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
			$document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
		}
		
		
		//set breadcrumbs
		if(is_object($menu) && $menu->query['view'] != 'category') {
			$pathway->addItem($category->title, '');
		}
		// Prepare category description
		$category->description = JHTML::_('content.prepare', $category->description);
		$baseurl = JURI::base();
		
		$script='var first = false;';
		if ($params->get('show_first_ans') && $items)
		$script='var first = '.$items[0]->id. ';';
		
		
		// CSS and JS
		$document->addStyleSheet($baseurl . "components/com_smfaq/css/smfaq.css");
		$document->addScript($baseurl . "components/com_smfaq/js/smfaq.js");
		$document->addScriptDeclaration($script); 

		if (isset( $category->image ) && $category->image != '')
		{
			$attribsimg['align']  = $category->image_position;
			$attribsimg['hspace'] = 6;

			// Use the static HTML library to build the image tag
			$category->image = JHTML::_('image', 'images/stories/'.$category->image, JText::_('COM_SMFAQ_SMFAQ'), $attribsimg);
		}
		
		if ($params->get('add_question') <= $user->get('aid', 0)) {
			
			$params->link_add = '<div><span id="addquestion" onclick="addquestion()" class="sm-button">'. JText::_('COM_SMFAQ_NEW_QUESTION') . '</span></div>';
			if ($user->get('gid') > 19) {
				$params->link_add = '<div><a href="index.php?option=com_smfaq&controller=admin&task=edit&catid='. $category->id .'&ret='.base64_encode($uri->toString()).'" class="sm-button"><span>' . JText::_('COM_SMFAQ_ADD_QUESTION') . '</span></a>';
				
				$params->link_add .= '<span class="sm-button" style="margin-left:10px" id="sm-noanswer" onclick="noanswer()">'.JText::_('COM_SMFAQ_SHOW_NO_ANSWER_QUESTIONS').'</span></div><div id="questionnoanswer"></div>';
				
			}
			$params->link_add .= '<input type="hidden" id="smcatid" value="'. $category->id. '" /><input type="hidden" id="Itemid" value="'. $menu->id. '" />';
		} else {
			if (($params->get('add_question') == '2') && ($user->get('gid') < 19)) {
				$params->link_add = null;
			} else {
				$params->link_add = Jtext::_('COM_SMFAQ_REGISTER_FOR_NEW_QUESTION');
			}
		}
		
		$this->assignRef('user',		$user);
		$this->assignRef('params',		$params);
		$this->assignRef('category',	$category);
		$this->assignRef('items',		$items);
		$this->assignRef('pagination',	$pagination);
		$this->assign('ret',	$uri->toString());

		parent::display($tpl);
	}
}
